'______________________________________________________
' BOXTRIM.CBL
' Macro written to trim and delete an area outside of a selected
' Rectangle. 
'
' by Peter Williams
' London Borough of Sutton - Construction & Property Consultancy 
' Oct. 1996
'______________________________________________________
'$INCLUDE 'cdi_incl.cbh'
 
sub main
 
   cv_osl = 0
   null_ptr = 0



' set up to select everything
dim extent1 as CDI_DD_POINT
dim extent2 as CDI_DD_POINT
extent1.x=-1000000000
extent1.y=1000000000
extent2.x=1000000000
extent2.y=-1000000000

CdiOslClear(0)


' set up arrays for inner box
dim corner1 as CDI_DD_POINT
dim corner2 as CDI_DD_POINT




Corner1:


   Call CdiDeleteCursor ()




corner1.x=1000000000
corner1.y=1000000000
corner2.x=1000000000
corner2.y=1000000000





   i_ret = CdiGetPoint("Select area to be trimmed - Corner 1",corner1, button_hit, menu_hit)

if button_hit=2 then  exit sub

If corner1.x=1000000000 and corner1.y=1000000000 then GOTO corner1



Corner2:

 J = CdiMakeCursor (osl, CDI_RECT_CURSOR, corner1, CDI_ABS_CURSOR_MOVE, cnr2, CDI_REL_CURSOR_MOVE)





   i_ret = CdiGetPoint("Select area to be trimmed - Corner 2",corner2, button_hit, menu_hit)

    if button_hit=2 then goto corner1


If corner2.x=1000000000 and corner2.y=1000000000 then
GOTO corner2
end if








' check for STUPID PEOPLE


If corner1.x=corner2.x AND corner2.y=corner1.y then

   i%=MsgBox("Points coincident - Reselect", 16, "Input Error")
GOTO Corner1
end if

 


' Check the input


' move the corners about

If corner1.x>corner2.x then
temp=corner1.x
corner1.x=corner2.x
corner2.x=temp
end if

If corner2.y>corner1.y then
temp=corner1.y
corner1.y=corner2.y
corner2.y=temp
end if




'Highlight everything


   prompt_1 = "" + chr$(0)
   prompt_2 = "" + chr$(0)
   selection_mode = CDI_SEL2D_ALL
   i_ret = CdiSelectbyWindow(cv_osl,prompt_1,prompt_2,CDI_OBJECT_SELECTION,CDI_TRUE,CDI_TRUE,extent1,extent2,selection_mode)
 

' Start Trimming

'Top

'  Trimming all objects on the OSL via 
'  CdiObjTrim(the OSL, trim line definition, side to trim, display color
'    Generating Relative Coordinates
   c1.x = extent1.x
   c1.y = corner1.y
   c2.x = extent2.x 
   c2.y = corner1.y
   c3.x = extent1.x
   c3.y = extent1.y
   i_ret = CdiObjTrim(cv_osl, c1, c2, c3, CDI_HIGHLIGHT)



'Bottom

'  Trimming all objects on the OSL via 
'  CdiObjTrim(the OSL, trim line definition, side to trim, display color
'    Generating Relative Coordinates
   c1.x = extent1.x
   c1.y = corner2.y
   c2.x = extent2.x 
   c2.y = corner2.y
   c3.x = extent2.x
   c3.y = extent2.y
   i_ret = CdiObjTrim(cv_osl, c1, c2, c3, CDI_HIGHLIGHT)


' Left side

'  Trimming all objects on the OSL via 
'  CdiObjTrim(the OSL, trim line definition, side to trim, display color
'    Generating Relative Coordinates
   c1.x = corner1.x
   c1.y = extent1.y
   c2.x = corner1.x 
   c2.y = extent2.y
   c3.x = extent1.x
   c3.y = extent1.y
   i_ret = CdiObjTrim(cv_osl, c1, c2, c3, CDI_HIGHLIGHT)


'Right side

'  Trimming all objects on the OSL via 
'  CdiObjTrim(the OSL, trim line definition, side to trim, display color
'    Generating Relative Coordinates
   c1.x = corner2.x
   c1.y = extent1.y
   c2.x = corner2.x 
   c2.y = extent2.y
   c3.x = extent2.x
   c3.y = extent2.y
   i_ret = CdiObjTrim(cv_osl, c1, c2, c3, CDI_HIGHLIGHT)






'Unselect the inner box

   prompt_1 = "" + chr$(0)
   prompt_2 = "" + chr$(0)
   selection_mode = CDI_SEL2D_ALL
   i_ret = CdiSelectbyWindow(cv_osl,prompt_1,prompt_2,CDI_OBJECT_SELECTION,CDI_TRUE,CDI_FALSE,corner1,corner2,selection_mode)
 

' delete any remaining bits

   i_ret = CdiObjDelete(cv_osl)


   Call CdiDeleteCursor ()
i_ret = CdiZoom(CDI_Zoom_Window,1,1,corner1,corner2)
'  Call CdiRedraw



end sub
